console.log( "Preloader.js loading.." );

function Preloader( srcs, images, onCompletex ) {
/*
	画像の相対アドレスリストを受け取り、
	exec()にてImageオブジェクトへロードし、
	リストのすべてをロード完了したら、onCompletex関数を呼ぶ。
*/
	this.images = images;
	
	this.preloadCnt = 0;
	this.onCompletex = onCompletex;
	this.srcs = new Array();
		for( var i = 0; i < srcs.length; i++ ) {
			var src = srcs[ i ];
			if( src.match( /^data:/ ) ) {
				//dataURLの場合
				this.srcs[ i ] = srcs[ i ];
			} else {
				//通常の場合（相対URL）
				var baseURL;
					if( location.href.match( /[^\/]+\.html$/ ) ) {
						baseURL = RegExp.leftContext;
					}
				this.srcs[ i ] = baseURL + srcs[ i ];
			}
		}
}

Preloader.prototype.exec = function() {
	this.preloadCnt = 0;
	for( var i = 0; i < this.srcs.length; i++ ) {
		var src = this.srcs[ i ];
		var image = new Image();
			image.onload = this.onloadx.bind( this );
			if( src.match( /^data:/ ) )
				image.src = src;
			else
				image.src = src + "?" + Math.random();
			this.images[ i ] = image;
	}
}

Preloader.prototype.onloadx = function( e ) {
	this.preloadCnt ++;
		//check.
		if( this.preloadCnt == this.srcs.length ) {
			this.onCompletex();
		}
}
